#pragma once

#include <d3dx10.h>
#include <string>
#include "../TFStructs.h"
#include "../BaseMesh.h"
#include <vector>

namespace Marabunta
{
	namespace Mesh
	{
		class StaticMesh : public BaseMesh
		{
			friend class MeshManager;
		public:
			virtual void SetupEffectVariables();
			virtual void SetEffectVariables(D3DXMATRIX* world);
			virtual void SetMaterial(Marabunta::Render::CompiledMaterial* mat);

		private:
			//can only be instantiated by the manager
			StaticMesh(Marabunta::Render::GeometryParameters geom);
			virtual ~StaticMesh();
			void Initialize(TFStaticMesh* mesh, MeshModel* model);

		private:
			ID3D10EffectShaderResourceVariable* _textureResource;
			static void LoadMesh(ID3D10Device* device,std::string fileName, MeshModel** model, TFStaticMesh** mesh);
			static void SetupMesh(ID3D10Device* device,MeshModel** model, TFStaticMesh** mesh, TFStaticVertex** vertices, UINT** indices);
		};
	}
}