#pragma once
#include <d3dx10.h>
//#include <string>
#include "spatial.h"

namespace Marabunta
{
	namespace Mesh
	{
		class BaseMesh;
	}
	namespace Render
	{
		struct CompiledMaterial;
	}

	namespace SceneManagement
	{
		class Camera;

		class Geometry : public Spatial
		{
		public:
			Geometry();
			Geometry(Mesh::BaseMesh* bm);
			virtual ~Geometry(void);

			virtual void SetupEffectVariables();
			virtual void SetEffectVariables();
			void SetCamera(Camera* cam);

			virtual void SetLayout();
			virtual void SetMaterial(Marabunta::Render::CompiledMaterial* mat);

			void UpdateDraw();
			void Render();
			Mesh::BaseMesh* GetMesh();
			void SetMesh(Mesh::BaseMesh* m);

		protected:
			Marabunta::Mesh::BaseMesh* _mesh;
		};
	}
}