#pragma once

#include <vector>
#include "spatial.h"

namespace Marabunta
{
	namespace SceneManagement
	{
		class Node : public Spatial
		{
		public:
			Node(void);
			virtual ~Node(void);

			virtual void UpdateGS(float dt);
			virtual Marabunta::SceneManagement::BoundingVolume*  UpdateBS();

			void UpdateDraw();

			void AddChild(Spatial* child);
			void RemoveChild(Spatial* child);
			void FlagForRemoval(Spatial* child, unsigned int listID);
			
		protected:
			std::vector<Spatial*> children;
			std::vector<std::vector<Spatial*>> _removalList;
			
		private:
		};
	}
}
