#include "WorldObject.h"
#include "Core/MarabuntaCore.h"

using namespace Marabunta::SceneManagement;

#pragma warning (disable:4482) // nonstandard enum type space warning 

/**
 * World Object extends Node and so exists in the scene graph. 
 * It however, adds an ID and a drawable and collidable boolean.
 * This can be extended by the application to make entites that 
 * exist in the game.
 *
 * @author		Matthew Bozarth
 * @updated		4/20/2009
 */

/**
 * constructor
 * @param id used to unique identify the world object. The ID should be assigned by the manager.
 */
WorldObject::WorldObject(unsigned int id) : Node()
{
	_type = ElementType::ET_WorldObject;
	_drawable = true;
	_collidable = true;
}

/**
 * Deconstructor
 */
WorldObject::~WorldObject(void)
{
}

/**
 * @return the id of the world object
 */
unsigned int WorldObject::GetID()
{
	return _id;
}

void WorldObject::UpdateGS(float dt)
{
	Node::UpdateGS(dt);
}

BoundingVolume* WorldObject::UpdateBS()
{
	return Node::UpdateBS();
}