#pragma once
#include <vector>

//i think we need this so it will know about the SceneManagement namespace
#include "SceneManagement/Elements/Geometry.h" 


struct lua_State;

using namespace Marabunta::SceneManagement;

namespace Marabunta
{
	namespace SceneManagement
	{
		class Camera;
		class Geometry;
	}
	namespace Render
	{
		class RenderGraph
		{
		public:
			RenderGraph(void);
			~RenderGraph(void);

			static void Initialize();

			static void Render(Camera* cam);
			static void AddRenderable(Geometry* g);
			
			static int RenderBV(lua_State* L);
			static void RegisterLuaFunctions(lua_State* L);

		private:
			static std::vector<Geometry*> renderables;
			static bool bvRender;
		};
	}
}
