#pragma once

#include <vector>

namespace Marabunta
{
	namespace SceneManagement
	{
		class Spatial;
		class Node;
		class Geometry;
		class BoundingVolume;
		class WorldObject;


		class SpatialGraph
		{
		public:
			SpatialGraph(void);
			~SpatialGraph(void);

			virtual void Update();
			void AddWorldObject(WorldObject* n);
			void RemoveWorldObject(WorldObject* n);
			void FlagForRemoval(WorldObject* n, unsigned int listID);
			bool FindCollision(BoundingVolume* in);
			std::vector<WorldObject*> FindCollisionList(BoundingVolume* in);

		private:
			//stores world objects that can be collided or rendered
			//optimize by keeping two lists, one for colliding, one for drawing? - matt
			std::vector<WorldObject*> _worldObjects;
			std::vector<std::vector<WorldObject*>> _removalList;
		};
	}
}