#pragma once
#include "Graphs/SceneGraph.h"
#include "Graphs/SpatialGraph.h"
#include "Graphs/RenderGraph.h"

namespace Marabunta
{
	namespace SceneManagement
	{
		class SceneGraph;
		class SpatialGraph;
		class Camera;
		class Terrain;

		class Scene
		{
		public:
			Scene(std::string name);
			virtual ~Scene(void);

			virtual void Update(float dt);
			virtual void Render();

			virtual void Activate();
			void Deactivate();
			std::string& Name();

			SceneGraph* pSceneGraph;
			SpatialGraph* pSpatialGraph;
			Camera* pCurrentCamera;
			Terrain* pTerrain;

			//true => update and render
			//multiple scenes can be active
			bool active;
		protected:
			std::string name;
		};
	}
}